''''''''''''''''''''''''''''''''''''''''
' Program    : Nothing 2 Something     '
' Name       : N2S Version 0.1         '
' Programmer : Yousuf Philips          '
' Company    : Y P I                   '
' Updated On : 29th of April 1999      '
' Email - [philipz85@hotmail.com]      '
' [http://members.xoom.com/Philipz/]   '
''''''''''''''''''''''''''''''''''''''''

'/*               Do not edit this file if you distribute it.              */'
'/*  (c) Copyrighted by YPI in 1998 | All Rights Reserved | Public Domain  */'

'/* This program has been created by YPI (Basic Programming Incorporation) */'
'/* as a utility to create & play N2S files.                               */'

'/* How this program works -                                               */'
'/*           Firstly it scans a given area of the screen for pixels.      */'
'/*           Then it creates random pixel locations for each pixel found. */'
'/*           Then it moves the random pixel to the actual pixel location. */'

'/* Its that simple, and it gives an excellent assortment of effects.      */'

'/* If you use any of this code in your program then you must credit YPI.  */'
'/* YPI has created an assortment of graphics loaders and players and they */'
'/* can all be found at <http://members.xoom.com/Philipz/>                 */'

TYPE YPIHeader
   ValidID AS STRING * 4
   PixelHeight AS LONG
   PixelWidth AS LONG
END TYPE

DECLARE SUB LoadYPB (FileName$)
DECLARE SUB LoadN2S (FileName$)

DIM SHARED PixelArray(3275, 4)
DIM SHARED NoOfPixels, Speed, TrueColor%, Erase$, BackGroundColor, BegColor, ColorMove, Demo

CLS
FILES "*.ypb"
FILES "*.n2s"
INPUT " Enter File Name [ N2S|YPB ] - ", FileName$

IF LCASE$(RIGHT$(FileName$, 3)) = "n2s" THEN
   CALL LoadN2S(FileName$)
ELSE
  
   'Variable List (Which can be changed)'
   Speed = 150: TrueColor% = 2: Erase$ = "y"
   BegColor = 19: ColorMove = 31: BackGroundColor = 0
   ScreenMinX = 0: ScreenMinY = 0: ScreenMaxX = 319: ScreenMaxY = 199
   RandMinX = 0: RandMinY = 0: RandMaxX = 319: RandMaxY = 199
  
   'Variable List (Which shouldn't be changed)'
   NoOfPixels = -1: ArrayPlace = -1: RBegColor = BegColor: Demo = 1

   IF LCASE$(RIGHT$(FileName$, 3)) = "ypb" THEN
      CALL LoadYPB(FileName$)
   ELSE
      SCREEN 13
      CIRCLE (149, 99), 100, 1
   END IF
  
   FOR U2D% = ScreenMinY TO ScreenMaxY
      FOR R2L% = ScreenMinX TO ScreenMaxX
         IF POINT(R2L%, U2D%) > 0 THEN
            NoOfPixels = NoOfPixels + 1
         END IF
      NEXT R2L%
   NEXT U2D%
  
   IF NoOfPixels > 3276 THEN
      PRINT "To many points on the Screen"
      END
   END IF

   RANDOMIZE TIMER
   RandX = (RandMaxX - RandMinX + 1): RandY = (RandMaxY - RandMinY + 1)
   FOR U2D% = ScreenMinY TO ScreenMaxY
      FOR R2L% = ScreenMinX TO ScreenMaxX
         IF POINT(R2L%, U2D%) > Black THEN
            ArrayPlace = ArrayPlace + 1
            PixelArray(ArrayPlace, 0) = CINT(RND * RandX) + RandMinX
            PixelArray(ArrayPlace, 1) = CINT(RND * RandY) + RandMinY
            PixelArray(ArrayPlace, 2) = POINT(R2L%, U2D%)
            PixelArray(ArrayPlace, 3) = (PixelArray(ArrayPlace, 0) - R2L%) / Speed
            PixelArray(ArrayPlace, 4) = (PixelArray(ArrayPlace, 1) - U2D%) / Speed
         END IF
         PSET (R2L%, U2D%), POINT(R2L%, U2D%) + 1
      NEXT R2L%
   NEXT U2D%
   ColorMove = (ColorMove - BegColor) / Speed
   CLS
END IF
      
   FOR Generate = 0 TO Speed
      FOR PutPixel = 0 TO NoOfPixels
         IF LCASE$(Erase$) = "y" AND Generate > -1 THEN
            PSET (CINT(PixelArray(PutPixel, 0) - (PixelArray(PutPixel, 3) * (Generate - 1))), CINT(PixelArray(PutPixel, 1) - (PixelArray(PutPixel, 4) * (Generate - 1)))), BackGroundColor
         END IF
         IF TrueColor% = 0 THEN
            PSET (CINT(PixelArray(PutPixel, 0) - (PixelArray(PutPixel, 3) * Generate)), CINT(PixelArray(PutPixel, 1) - (PixelArray(PutPixel, 4) * Generate))), BegColor
         ELSEIF TrueColor% = 1 THEN
            PSET (CINT(PixelArray(PutPixel, 0) - (PixelArray(PutPixel, 3) * Generate)), CINT(PixelArray(PutPixel, 1) - (PixelArray(PutPixel, 4) * Generate))), RND * 256
         ELSE
            PSET (CINT(PixelArray(PutPixel, 0) - (PixelArray(PutPixel, 3) * Generate)), CINT(PixelArray(PutPixel, 1) - (PixelArray(PutPixel, 4) * Generate))), PixelArray(PutPixel, 2)
         END IF
      NEXT PutPixel
      BegColor = BegColor + ColorMove
   NEXT Generate

   '/* Regenerates The Original Image                                      */'
   FOR PutPixel = 0 TO NoOfPixels
      PSET (PixelArray(PutPixel, 0) - (PixelArray(PutPixel, 3) * Speed), PixelArray(PutPixel, 1) - (PixelArray(PutPixel, 4) * Speed)), PixelArray(PutPixel, 2)
   NEXT PutPixel
   SLEEP

IF LCASE$(RIGHT$(FileName$, 3)) <> "n2s" THEN
   SCREEN 2: SCREEN 0
   CLS
   PRINT " Save File As N2S File [ Y / N ] - "
   DO
      Answer$ = INPUT$(1)
      IF UCASE$(Answer$) = "N" THEN END
   LOOP UNTIL UCASE$(Answer$) = "Y"
   PRINT " Enter File Name - ";
   INPUT "", FileName$
   OPEN FileName$ FOR OUTPUT AS #1
   WRITE #1, NoOfPixels, Speed, TrueColor%, Erase$, BackGroundColor, RBegColor, ColorMove, Demo
   FOR PutPixel = 0 TO NoOfPixels STEP 2
      WRITE #1, PixelArray(PutPixel, 0), PixelArray(PutPixel, 1), PixelArray(PutPixel, 2), PixelArray(PutPixel, 3), PixelArray(PutPixel, 4), PixelArray(PutPixel + 1, 0), PixelArray(PutPixel + 1, 1), PixelArray(PutPixel + 1, 2), PixelArray(PutPixel + _
 1, 3), PixelArray(PutPixel + 1, 4)
   NEXT PutPixel
END IF

SUB LoadN2S (FileName$)

OPEN FileName$ FOR BINARY AS #1
IF LOF(1) = 0 THEN
   PRINT " File Is Empty"
   CLOSE #1
   KILL FileName$
   END
END IF
CLOSE #1
   
OPEN FileName$ FOR INPUT AS #1
INPUT #1, NoOfPixels, Speed, TrueColor%, Erase$, BackGroundColor, BegColor, ColorMove, Demo
FOR X = 0 TO NoOfPixels
   INPUT #1, XPoint, YPoint, Colour, XMove, YMove
   PixelArray(X, 0) = XPoint
   PixelArray(X, 1) = YPoint
   PixelArray(X, 2) = Colour
   PixelArray(X, 3) = XMove
   PixelArray(X, 4) = YMove
NEXT X
CLOSE #1
SCREEN 13

END SUB

DEFINT A-Z
SUB LoadYPB (FileName$)

DIM YPIHeader AS YPIHeader

OPEN FileName$ FOR BINARY AS #1
IF LOF(1) = 0 THEN
   PRINT " File Is Empty"
   CLOSE #1
   KILL FileName$
   END
END IF

GET #1, , YPIHeader
SCREEN 13
IF YPIHeader.ValidID = "YPI " THEN
   CenterX = (320 - YPIHeader.PixelWidth) \ 2
   CenterY = (200 - YPIHeader.PixelHeight) \ 2
   PixelColor$ = SPACE$(YPIHeader.PixelWidth)
   FOR Y = 0 TO YPIHeader.PixelHeight - 1
      GET #1, , PixelColor$
      FOR X = 0 TO YPIHeader.PixelWidth - 1
         PixelColor = ASC(MID$(PixelColor$, X + 1, 1))
         IF PixelColor <> 31 THEN
            PSET (CenterX + X, CenterY + Y), PixelColor
         END IF
      NEXT X
   NEXT Y
ELSE
   CLOSE
   SCREEN 2: SCREEN 0
   PRINT " Unknown Format "
   END
END IF
CLOSE #1

END SUB

